package cs108;

public final class Composed implements Image<ColorRGB> {
    private final Image<ColorRGB> bg, fg;
    private final Image<Float> mask;

    public Composed(Image<ColorRGB> bg, Image<ColorRGB> fg, Image<Float> mask) {
        this.bg = bg;
        this.fg = fg;
        this.mask = mask;
    }

    @Override
    public ColorRGB apply(float x, float y) {
        return bg.apply(x, y).mixWith(fg.apply(x, y), mask.apply(x, y));
    }
}