package cs108;

import static java.lang.Math.cos;
import static java.lang.Math.sin;

public final class Rotated<T> implements Image<T> {
    private final Image<T> image;
    private final float cosA, sinA;

    public Rotated(Image<T> image, float angle) {
        this.image = image;
        this.cosA = (float) cos(-angle);
        this.sinA = (float) sin(-angle);
    }

    @Override
    public T apply(float x, float y) {
        float x1 = x * cosA - y * sinA;
        float y1 = x * sinA + y * cosA;
        return image.apply(x1, y1);
    }
}